"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.CredPropose = void 0;
const class_transformer_1 = require("class-transformer");
const class_validator_1 = require("class-validator");
/**
 * Class providing validation for the V2 credential proposal payload.
 *
 * The v1 message contains the properties directly in the message, which means they are
 * validated using the class validator decorators. In v2 the attachments content is not transformed
 * when transforming the message to a class instance so the content is not verified anymore, hence this
 * class.
 *
 */
class CredPropose {
    constructor(options) {
        if (options) {
            this.schemaIssuerDid = options.schemaIssuerDid;
            this.schemaId = options.schemaId;
            this.schemaName = options.schemaName;
            this.schemaVersion = options.schemaVersion;
            this.credentialDefinitionId = options.credentialDefinitionId;
            this.issuerDid = options.issuerDid;
        }
    }
}
__decorate([
    class_transformer_1.Expose({ name: 'schema_issuer_did' }),
    class_validator_1.IsString(),
    class_validator_1.IsOptional(),
    __metadata("design:type", String)
], CredPropose.prototype, "schemaIssuerDid", void 0);
__decorate([
    class_transformer_1.Expose({ name: 'schema_id' }),
    class_validator_1.IsString(),
    class_validator_1.IsOptional(),
    __metadata("design:type", String)
], CredPropose.prototype, "schemaId", void 0);
__decorate([
    class_transformer_1.Expose({ name: 'schema_name' }),
    class_validator_1.IsString(),
    class_validator_1.IsOptional(),
    __metadata("design:type", String)
], CredPropose.prototype, "schemaName", void 0);
__decorate([
    class_transformer_1.Expose({ name: 'schema_version' }),
    class_validator_1.IsString(),
    class_validator_1.IsOptional(),
    __metadata("design:type", String)
], CredPropose.prototype, "schemaVersion", void 0);
__decorate([
    class_transformer_1.Expose({ name: 'cred_def_id' }),
    class_validator_1.IsString(),
    class_validator_1.IsOptional(),
    __metadata("design:type", String)
], CredPropose.prototype, "credentialDefinitionId", void 0);
__decorate([
    class_transformer_1.Expose({ name: 'issuer_did' }),
    class_validator_1.IsString(),
    class_validator_1.IsOptional(),
    __metadata("design:type", String)
], CredPropose.prototype, "issuerDid", void 0);
exports.CredPropose = CredPropose;
//# sourceMappingURL=CredPropose.js.map