import type { CredOffer } from 'indy-sdk';
import { AgentMessage } from '../../../../../agent/AgentMessage';
import { Attachment } from '../../../../../decorators/attachment/Attachment';
import { V1CredentialPreview } from '../V1CredentialPreview';
export declare const INDY_CREDENTIAL_OFFER_ATTACHMENT_ID = "libindy-cred-offer-0";
export interface OfferCredentialMessageOptions {
    id?: string;
    comment?: string;
    offerAttachments: Attachment[];
    credentialPreview: V1CredentialPreview;
    attachments?: Attachment[];
}
/**
 * Message part of Issue Credential Protocol used to continue or initiate credential exchange by issuer.
 *
 * @see https://github.com/hyperledger/aries-rfcs/blob/master/features/0036-issue-credential/README.md#offer-credential
 */
export declare class V1OfferCredentialMessage extends AgentMessage {
    constructor(options: OfferCredentialMessageOptions);
    readonly type: string;
    static readonly type: import("../../../../../utils/messageType").ParsedMessageType;
    comment?: string;
    credentialPreview: V1CredentialPreview;
    messageAttachment: Attachment[];
    get indyCredentialOffer(): CredOffer | null;
    getAttachmentById(id: string): Attachment | undefined;
}
