"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.MessageDeliveryHandler = void 0;
const helpers_1 = require("../../../agent/helpers");
const messages_1 = require("../messages");
class MessageDeliveryHandler {
    constructor(mediationRecipientService) {
        this.supportedMessages = [messages_1.MessageDeliveryMessage];
        this.mediationRecipientService = mediationRecipientService;
    }
    async handle(messageContext) {
        const connection = messageContext.assertReadyConnection();
        const deliveryReceivedMessage = await this.mediationRecipientService.processDelivery(messageContext);
        if (deliveryReceivedMessage) {
            return helpers_1.createOutboundMessage(connection, deliveryReceivedMessage);
        }
    }
}
exports.MessageDeliveryHandler = MessageDeliveryHandler;
//# sourceMappingURL=MessageDeliveryHandler.js.map