import type { Agent } from '../../agent/Agent';
import type { UpdateConfig } from './updates';
export declare class UpdateAssistant {
    private agent;
    private storageUpdateService;
    private updateConfig;
    constructor(agent: Agent, updateConfig: UpdateConfig);
    initialize(): Promise<void>;
    isUpToDate(): Promise<boolean>;
    getCurrentAgentStorageVersion(): Promise<`${number}.${number}`>;
    static get frameworkStorageVersion(): `${number}.${number}`;
    getNeededUpdates(): Promise<import("./updates").Update[]>;
    update(): Promise<string | undefined>;
    private getBackupPath;
    private createBackup;
    private restoreBackup;
}
